﻿/*==============================================================================
 * Author:深度训练
 * Create time: 2013-08-04
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 *==============================================================================*/

namespace ConsoleApplication1.DynamicBehavior
{
    using System;
    using System.Dynamic;

    public static class EntityDynamicBehaviorExtent
    {
        /// <summary>
        /// Add dynamic method.
        /// </summary>
        /// <param name="entity"></param>
        /// <returns></returns>
        public static ExpandoObject AddExten(this ExpandoObject entity)
        {
            dynamic dy = entity as dynamic;
            dy.Add = new Func<ExpandoObject>(() => { Console.WriteLine("add " + entity); return entity; });
            return entity;
        }
        /// <summary>
        /// where  dynamic method. 
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="entity"></param>
        /// <param name="where"></param>
        /// <returns></returns>
        public static ExpandoObject WhereExten<T>(this ExpandoObject entity, Func<T, bool> where)
        {
            dynamic dy = entity as dynamic;
            dy.Where = where;
            return entity;
        }
    }
}
