﻿using ConsoleApplication1.DomainModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;
using System.Runtime;

namespace ConsoleApplication1
{
    using ConsoleApplication1.DynamicBehavior;
    using DomainModel.Specification;
    using System.IO;
    class Program
    {
        static void Main(string[] args)
        {
            using (Repository.DesignBuilder_DataBaseContext context = new Repository.DesignBuilder_DataBaseContext())
            {
                var employees = from emp in context.Employee where emp.EId == "Wqp123" select emp;

                Employee employee = new Employee() { EId = "Wqp123" };

                var entityOpeartion = DynamicBehavior.EntityDymanicBehavior.GetEntityBehavior<Employee>(employee);

                entityOpeartion.Add();

                Employee employee1 = new Employee() { EId = "Wqp123" };
                var dynamicEntity = DynamicBehavior.EntityDymanicBehavior.GetEntityBehavior<Employee>(employee1);
                (dynamicEntity as System.Dynamic.ExpandoObject).AddExten().WhereExten<Employee>(emp =>
                {
                    Console.WriteLine("Where Method.");
                    return emp.EId == "Wqp123";
                });
                dynamicEntity.Add().Where(employee1);

                Employee employee2 = new Employee("Wqp123", "Wqp", SexType.Male, new Factory(() =>
                {
                    return new Address() { AddressName = "Shanghai" };
                }));



                EmployeeSpecificationAdd specification = new EmployeeSpecificationAdd(employee2);

                Stream stream = File.Open("specification.xml", FileMode.Create);
                BinaryFormatter formattter = new BinaryFormatter();
                formattter.Serialize(stream, specification);

                stream.Seek(0, SeekOrigin.Begin);
                specification = formattter.Deserialize(stream) as EmployeeSpecificationAdd;

                stream.Close();
                stream.Dispose();
                if (specification.IsCheck())
                {
                    Console.WriteLine("Ok...");
                }
            }
        }
    }
}
