﻿/*==============================================================================
 * Author:深度训练
 * Create time: 2013-08-04
 * Blog Address:http://www.cnblogs.com/wangiqngpei557/
 * Author Description:特定领域软件工程实践；
 *==============================================================================*/

namespace ORM.Meta
{
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Database Table meta.
    /// </summary>
    public class MetaTable : List<MetaColumn>
    {
        /// <summary>
        /// Table name.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Entity name.
        /// </summary>
        public string EntityName { get; set; }

        /// <summary>
        /// Get column by column name.
        /// </summary>
        /// <param name="name">Column name.</param>
        /// <returns><see cref="ORM.MetaColumn"/></returns>
        public MetaColumn GetColumnByName(string name)
        {
            var column = from item in this.ToList() where item.CoumnName == name select item;
            return column.FirstOrDefault();
        }
    }
}
